import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsSpecValue, CmsSpecValueParam } from './model';


/**
 * 分页查询规格值
 */
export async function pageCmsSpecValue(params: CmsSpecValueParam) {
  const res = await request.get<ApiResult<PageResult<CmsSpecValue>>>(
    '/cms/cms-spec-value/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询规格值列表
 */
export async function listCmsSpecValue(params?: CmsSpecValueParam) {
  const res = await request.get<ApiResult<CmsSpecValue[]>>(
    '/cms/cms-spec-value',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加规格值
 */
export async function addCmsSpecValue(data: CmsSpecValue) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-spec-value',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改规格值
 */
export async function updateCmsSpecValue(data: CmsSpecValue) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-spec-value',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除规格值
 */
export async function removeCmsSpecValue(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-spec-value/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除规格值
 */
export async function removeBatchCmsSpecValue(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-spec-value/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询规格值
 */
export async function getCmsSpecValue(id: number) {
  const res = await request.get<ApiResult<CmsSpecValue>>(
    '/cms/cms-spec-value/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
